#include "databox.h"

/* $B%Q!<%D$NJ8;zNs9`L\"*(Bkdat$B$K4X$9$k7W;;(B */
void parseparts(PARTSDATA *pdat, W type)
{
    W	i, j, k, keynum, attr, maxnum;
    TC  *ptr, tmp;
    PARTS_SDAT *psdat;
    
    switch (type) {
    case TB_PARTS:
    case XB_PARTS:
	maxnum = 1;
	ptr = pdat->parts.tb.text;
	goto SET_KDAT;
    case NB_PARTS: /* $BI,MWL5$7(B */
	break;
    case SB_PARTS:
	psdat = (PARTS_SDAT *)(pdat->kdat);
	ptr = pdat->parts.sb.fmt;
	if ((*ptr & MC_ATTR) == MC_ATTR) {
	    psdat[0].kdat[0].attr    = MC_ATTR;
	    ptr++;
	    psdat[0].kdat[0].chcol   = *((W *)ptr);
	    ptr += 2;
	    psdat[0].kdat[0].class   = *(ptr++);
	    psdat[0].kdat[0].fattr   = *(ptr++);
	    psdat[0].kdat[0].csize.x = *(ptr++);
	    psdat[0].kdat[0].csize.y = *(ptr++);
	}
	else {
	    if (*ptr & MC_STR) {
		ptr++;
	    }
	    psdat[0].kdat[0].attr    = MC_STR;
	}   
	i = 1;
	while (*ptr) {
	    switch (*ptr & 0xfc00) {
	    case 0: /* $B8GDjJ8;zNs(B */
		k = 0;
		psdat[i].attr = 0;
		while (*ptr && ((*ptr & 0xfc00) != 0x0800) &&
		       ((*ptr & 0xfc00) != 0x0c00)) {
		    psdat[i].kdat[0].tcode[k++] = *(ptr++);
		}
		pdat->kdat[i].tcode[k] = TNULL;
		break;
	    case 0x0800: /* $B9`L\%U%#!<%k%I;XDj(B */
		psdat[i].attr = 1;
		psdat[i].textnum = *ptr & 0x00ff;
		ptr ++;
		j = 0;
		while (*ptr) {
		    if ((*ptr & MC_ATTR) == MC_ATTR) {
			psdat[i].kdat[j].attr    = MC_ATTR;
			ptr++;
			psdat[i].kdat[j].chcol   = *((W *)ptr);
			ptr += 2;
			psdat[i].kdat[j].class   = *(ptr++);
			psdat[i].kdat[j].fattr   = *(ptr++);
			psdat[i].kdat[j].csize.x = *(ptr++);
			psdat[i].kdat[j].csize.y = *(ptr++);
		    }
		    else {
			ptr++;
			psdat[i].kdat[j].attr    = MC_STR;
		    }
		    k = 0;
		    while (*ptr && ((*ptr & 0xf000) != MC_STR)) {
			psdat[i].kdat[j].tcode[k++] = *(ptr++);
		    }
		    psdat[i].kdat[j].tcode[k++] = TNULL;
		    ptr++;
		    j++;
		}
		psdat[i].knum = j;
		break;
	    case 0x0c00: /* $B?tCM%U%#!<%k%I;XDj(B */
		psdat[i].attr = 2;
		psdat[i].textnum = *ptr & 0x00ff;
		psdat[i].z       = (*ptr & 0x0200) ? 1 : 0;
		psdat[i].a       = (*ptr & 0x0100) ? 1 : 0;
		ptr ++;
		psdat[i].minnum  = *(ptr++);
		psdat[i].maxnum  = *(ptr++);
		break;
	    }
	    i++;
	    if (i == 16) {
		break;
	    }
	}
	if (i != pdat->parts.sb.nfld + 1) {
	    printf("pp %d %d\n", i, pdat->parts.sb.nfld);
	}
	break;
    case AS_PARTS:
    case MS_PARTS:
    case WS_PARTS:
    case SS_PARTS:
	maxnum = (type == AS_PARTS || type == MS_PARTS) ? 1 :
	    ((type == WS_PARTS == 32) ? 64 : 0);
	ptr = pdat->parts.ss.name;
    SET_KDAT:
	i = 0;
	while (*ptr) {
	    attr = pdat->kdat[i].attr = *(ptr++);
	    
	    if ((attr & MC_FIG) == MC_FIG) {
		tmp = *(ptr++);
		pdat->kdat[i].dtype  = tmp >> 12;
		pdat->kdat[i].dnum   = tmp & 0x0fff;
		pdat->kdat[i].length = *(ptr++);
	    }
	    else {
		if ((attr & MC_ATTR) == MC_ATTR) {
		    pdat->kdat[i].chcol  = *((W *)ptr);
		    ptr += 2;
		    pdat->kdat[i].class   = *(ptr++);
		    pdat->kdat[i].fattr   = *(ptr++);
		    pdat->kdat[i].csize.x = *(ptr++);
		    pdat->kdat[i].csize.y = *(ptr++);
		}
		k = 0;
		while (*ptr && ((*ptr & 0xf000) != MC_STR)) {
		    pdat->kdat[i].tcode[k++] = *(ptr++);
		}
		pdat->kdat[i].tcode[k] = TNULL;
	    }
	    i++;
	    if (i == maxnum) {
		break;
	    }
	}
	pdat->knum = i;
	break;
    case PA_PARTS: /* $BI,MWL5$7(B */
    case PM_PARTS:
    case VL_PARTS:
	break;
    }
}

/* kdat$B"*%Q!<%D$NJ8;zNs9`L\4X$9$k7W;;(B */
void setpartsptr(PARTSDATA *pdat, W type)
{
    W	i, j, k, keynum, attr;
    TC  *ptr, *motoptr, tmp;
    PARTS_SDAT *psdat;

    switch (type) {
    case TB_PARTS:
    case XB_PARTS:
	if (pdat->parts.tb.text) {
	    free(pdat->parts.tb.text);
	}
	motoptr = ptr = pdat->parts.tb.text =
	    (TC *)checkmalloc(sizeof(TC) * 1000);
	/* MC_STR, MC_ATTR$B$N$_M-8z(B */
	/* pdat->kdat[0].attr &= (MC_STR | MC_ATTR); */
	goto SET_TEXTPTR;
    case NB_PARTS: /* $BI,MWL5$7(B */
	break;
    case SB_PARTS:
	if (pdat->parts.sb.fmt) {
	    free(pdat->parts.sb.fmt);
	}
	motoptr = ptr = pdat->parts.sb.fmt =
	    (TC *)checkmalloc(sizeof(TC) * 5000);
	psdat = (PARTS_SDAT *)(pdat->kdat);
	if ((psdat[0].kdat[0].attr & MC_ATTR) == MC_ATTR) {
	    *(ptr++) = MC_ATTR;
	    *((W *)ptr) = psdat[0].kdat[0].chcol;
	    ptr += 2;
	    *(ptr++) = psdat[0].kdat[0].class;
	    *(ptr++) = psdat[0].kdat[0].fattr;
	    *(ptr++) = psdat[0].kdat[0].csize.x;
	    *(ptr++) = psdat[0].kdat[0].csize.y;
	}
	else {
	    *(ptr++) = MC_STR;
	}
	for (i = 1 ; i <= pdat->parts.sb.nfld ; i++) {
	    switch (psdat[i].attr) {
	    case 0: /* $B8GDjJ8;zNs(B */
		k = 0;
		while (psdat[i].kdat[0].tcode[k]) {
		    *(ptr++) = psdat[i].kdat[0].tcode[k++];
		}	
		break;
	    case 1: /* $B9`L\%U%#!<%k%I;XDj(B */
		*(ptr++) = 0x0800 + psdat[i].textnum;
		for (j = 0 ; j < psdat[j].knum ; j++) {
		    if ((psdat[0].kdat[0].attr & MC_ATTR) == MC_ATTR) {
			*(ptr++) = MC_ATTR;
			*((W *)ptr) = psdat[i].kdat[j].chcol;
			ptr += 2;
			*(ptr++) = psdat[i].kdat[j].class;
			*(ptr++) = psdat[i].kdat[j].fattr;
			*(ptr++) = psdat[i].kdat[j].csize.x;
			*(ptr++) = psdat[i].kdat[j].csize.y;
		    }
		    else {
			*(ptr++) = MC_STR;
		    }
		    k = 0;
		    while (psdat[i].kdat[j].tcode[k]) {
			*(ptr++) = psdat[i].kdat[j].tcode[k++];
		    }
		}
		*(ptr++) = 0;
		break;
	    case 2: /* $B?tCM%U%#!<%k%I;XDj(B */
		*(ptr++) = 0x0c00 + psdat[i].textnum +
		    ((psdat[i].z) ? 0x0200 : 0) +
			((psdat[i].a) ? 0x0100 : 0);
		*(ptr++) = psdat[i].minnum;
		*(ptr++) = psdat[i].maxnum;
		break;
	    }
	}
	*(ptr++) = TNULL;
	break;
    case AS_PARTS:
    case MS_PARTS: 
	pdat->knum = 1; /* $BG0$N0Y(B */
    case WS_PARTS:
    case SS_PARTS: 
	if (pdat->parts.ss.name) {
	    free(pdat->parts.ss.name);
	}
	motoptr = ptr = pdat->parts.ss.name =
	    (TC *)checkmalloc(sizeof(TC) * 1000);
	/* MC_STR, MC_FIG, MC_ATTR$B$N$_M-8z(B */
	/* pdat->kdat[0].attr &= (MC_STR | MC_FIG | MC_ATTR); */
    SET_TEXTPTR:
	for (i = 0 ; i < pdat->knum ; i++) {
	    *(ptr++) = attr = pdat->kdat[i].attr;	    
	    if ((attr & MC_FIG) == MC_FIG) {
		*(ptr++) = (pdat->kdat[i].dtype << 12) + pdat->kdat[i].dnum;
		*(ptr++) = pdat->kdat[i].length;
	    }
	    else {
		if ((attr & MC_ATTR) == MC_ATTR) {
		    *((W *)ptr) = pdat->kdat[i].chcol;
		    ptr += 2;
		    *(ptr++) = pdat->kdat[i].class;
		    *(ptr++) = pdat->kdat[i].fattr;
		    *(ptr++) = pdat->kdat[i].csize.x;
		    *(ptr++) = pdat->kdat[i].csize.y;
		}
		k = 0;
		while (pdat->kdat[i].tcode[k]) {
		    *(ptr++) = pdat->kdat[i].tcode[k++];
		}
	    }
	}
	*(ptr++) = TNULL;
	break;
    case PA_PARTS: /* $BI,MWL5$7(B */
    case PM_PARTS:
    case VL_PARTS:
	break;
    }
    pdat->ptrlen = (ptr - motoptr) * sizeof(TC);
}

/* $B%a%K%e!<$NJ8;zNs9`L\"*(Bkdat$B$K4X$9$k7W;;(B */
void parsemenu(MENUDATA *mdat)
{
    W	i, j, k, keynum, attr;
    TC  *ptr, tmp;
    for (i = 0 ; i < mdat->nitem ; i++) {
	ptr = mdat->mitem[i].ptr;
	j = 0;
	while (*ptr) {
	    attr = mdat->kdat[i][j].attr = *(ptr++);
	    if ((attr & MC_LINE) == MC_LINE) {
	    }
	    else if ((attr & MC_FIG) == MC_FIG) {
		tmp = *(ptr++);
		mdat->kdat[i][j].dtype  = tmp >> 12;
		mdat->kdat[i][j].dnum   = tmp & 0x0fff;
		mdat->kdat[i][j].length = *(ptr++);
	    }
	    else {
		if ((attr & MC_ATTR) == MC_ATTR) {
		    mdat->kdat[i][j].chcol  = *((W *)ptr);
		    ptr += 2;
		    mdat->kdat[i][j].class   = *(ptr++);
		    mdat->kdat[i][j].fattr   = *(ptr++);
		    mdat->kdat[i][j].csize.x = *(ptr++);
		    mdat->kdat[i][j].csize.y = *(ptr++);
		    if (mdat->kdat[i][j].csize.x > 16) {
			mdat->kdat[i][j].csize.x = 16;
		    }
		    if (mdat->kdat[i][j].csize.y > 16) {
			mdat->kdat[i][j].csize.y = 16;
		    }
		}
		/* MC_KEY */
		if (attr & 0x00f0) {
		    mdat->kdat[i][j].keynum = (attr & 0x0f0) >> 4;
		    for (k = 0 ; k < mdat->kdat[i][j].keynum ; k++) {
			mdat->kdat[i][j].keycode[k] = *(ptr++);
		    }
		    mdat->kdat[i][j].keyon = 1;
		}
		else {
		    mdat->kdat[i][j].keynum = 0;
		    mdat->kdat[i][j].keyon  = 0;
		}
		k = 0;
		while (*ptr && ((*ptr & 0xf000) != MC_STR)) {
		    mdat->kdat[i][j].tcode[k++] = *(ptr++);
		}
		mdat->kdat[i][j].tcode[k] = TNULL;
	    }
	    j++;
	    if (j == 32) {
		break;
	    }
	}
	mdat->cnitem[i] = j;
    }
}

/* kdat$B"*%a%K%e!<$NJ8;zNs9`L\4X$9$k7W;;(B */
void setmenuptr(MENUDATA *mdat, W i)
{
    W	j, k, keynum, attr;
    TC  *ptr, tmp;

    if (mdat->mitem[i].ptr) {
	free(mdat->mitem[i].ptr);
    }
    ptr = mdat->mitem[i].ptr = (TC *)checkmalloc(sizeof(TC) * 1000);
    for (j = 0 ; j < mdat->cnitem[i] ; j++) {
	*(ptr++) = mdat->kdat[i][j].attr;
	if ((mdat->kdat[i][j].attr & MC_LINE) == MC_LINE) {
	}
	else if ((mdat->kdat[i][j].attr & MC_FIG) == MC_FIG) {
	    *(ptr++) = (mdat->kdat[i][j].dtype << 12) +
		mdat->kdat[i][j].dnum;
	    *(ptr++) = mdat->kdat[i][j].length;
	}
	else {
	    if ((mdat->kdat[i][j].attr & MC_ATTR) == MC_ATTR) {
		*((W *)ptr) = mdat->kdat[i][j].chcol;
		ptr += 2;
		*(ptr++) = mdat->kdat[i][j].class = -1;
		*(ptr++) = mdat->kdat[i][j].fattr;
		*(ptr++) = mdat->kdat[i][j].csize.x;
		*(ptr++) = mdat->kdat[i][j].csize.y;
	    }
	    /* MC_KEY */
	    if (mdat->kdat[i][j].attr & 0x00f0) {
		for (k = 0 ; k < mdat->kdat[i][j].keynum ; k++) {
		    *(ptr++) = mdat->kdat[i][j].keycode[k];
		}
	    }
	    k = 0;
	    while (mdat->kdat[i][j].tcode[k]) {
		*(ptr++) = mdat->kdat[i][j].tcode[k++];
	    }
	}
    }
    *(ptr++) = TNULL;
    mdat->ptrlen[i] = (ptr - mdat->mitem[i].ptr) * sizeof(TC);
}

/* $BHFMQ%a%K%e!<$NJ8;zNs9`L\"*(Bkdat$B$K4X$9$k7W;;(B */
void parsegmenu(GMENUDATA *gmdat)
{
    W	j, k, keynum, attr;
    TC  *ptr, tmp;

    ptr = gmdat->gmenu.ptr;
    j = 0;
    while (*ptr) {
	attr = gmdat->gkdat[j].attr = *(ptr++);
	
	if ((attr & MC_LINE) == MC_LINE) {
	}
	else if ((attr & MC_FIG) == MC_FIG) {
	    tmp = *(ptr++);
	    gmdat->gkdat[j].dtype  = tmp >> 12;
	    gmdat->gkdat[j].dnum   = tmp & 0x0fff;
	    ptr++;
	}
	else {
	    if ((attr & MC_ATTR) == MC_ATTR) {
		gmdat->gkdat[j].chcol  = *((W *)ptr);
		ptr += 2;
		gmdat->gkdat[j].class   = *(ptr++);
		gmdat->gkdat[j].fattr   = *(ptr++);
		gmdat->gkdat[j].csize.x = *(ptr++);
		gmdat->gkdat[j].csize.y = *(ptr++);
		if (gmdat->gkdat[j].csize.x > 16) {
		    gmdat->gkdat[j].csize.x = 16;
		}
		if (gmdat->gkdat[j].csize.y > 16) {
		    gmdat->gkdat[j].csize.y = 16;
		}
	    }
	    k = 0;
	    while (*ptr && ((*ptr & 0xf000) != MC_STR)) {
		gmdat->gkdat[j].tcode[k++] = *(ptr++);
	    }
	    gmdat->gkdat[j].tcode[k] = TNULL;
	}
	j++;
	if (j == 32) {
	    break;
	}
    }
}

/* kdat$B"*%a%K%e!<$NJ8;zNs9`L\4X$9$k7W;;(B */
void setgmenuptr(GMENUDATA *gmdat)
{
    W	j, k, keynum, attr;
    TC  *ptr, tmp;

    if (gmdat->gmenu.ptr) {
	free(gmdat->gmenu.ptr);
    }
    ptr = gmdat->gmenu.ptr = (TC *)checkmalloc(sizeof(TC) * 1000);

    for (j = 0 ; j < gmdat->gmenu.nitem ; j++) {
	*(ptr++) = gmdat->gkdat[j].attr;
	if ((gmdat->gkdat[j].attr & MC_LINE) == MC_LINE) {
	}
	else if ((gmdat->gkdat[j].attr & MC_FIG) == MC_FIG) {
	    *(ptr++) = (gmdat->gkdat[j].dtype << 12) +
		gmdat->gkdat[j].dnum;
	    ptr++;
	}
	else {
	    if ((gmdat->gkdat[j].attr & MC_ATTR) == MC_ATTR) {
		*((W *)ptr) = gmdat->gkdat[j].chcol;
		ptr += 2;
		*(ptr++) = gmdat->gkdat[j].class = -1;
		*(ptr++) = gmdat->gkdat[j].fattr;
		*(ptr++) = gmdat->gkdat[j].csize.x;
		*(ptr++) = gmdat->gkdat[j].csize.y;
	    }
	    k = 0;
	    while (gmdat->gkdat[j].tcode[k]) {
		*(ptr++) = gmdat->gkdat[j].tcode[k++];
	    }
	}
    }
    *(ptr++) = TNULL;
    gmdat->ptrlen = (ptr - gmdat->gmenu.ptr) * sizeof(TC);
}

